<!-- <!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Phone Recommender</title>
    <link rel="stylesheet" href="../static/index.css" />
    <style>
      body {
        overflow: hidden;
      }
      .modal {
        display: none;
        position: fixed;
        z-index: 1;
        padding-top: 60px;
        left: 0;
        top: 0;
        width: 100%;
        height: 100%;
        overflow: auto;
        background-color: rgba(0, 0, 0, 0.4);
      }
      .modal-content {
        background-color: #fefefe;
        margin: 5% auto;
        padding: 20px;
        border: 1px solid #888;
        width: 80%;
        text-align: center;
      }
      .close {
        color: #aaa;
        float: right;
        font-size: 28px;
        font-weight: bold;
      }
      .close:hover,
      .close:focus {
        color: black;
        text-decoration: none;
        cursor: pointer;
      }
      .try-other-models-btn {
        background-color: #4caf50;
        color: white;
        border: none;
        padding: 10px 20px;
        font-size: 16px;
        cursor: pointer;
        margin-top: 20px;
        display: block;
      }
      .try-other-models-btn:hover {
        background-color: #45a049;
      }
    </style>
  </head>
  <body>
    <div id="section1" class="section section-start">
      <div class="container">
        <header>Get The Phone Of Your Choice</header>
        <a href="#" class="start-button">START</a>
      </div>
    </div>
    <div id="section2" class="section section-stacy">
      <div class="container">
        <div class="content">
          <div class="model">
            <h2>Models Used</h2>
            <h3>Decision Tree</h3>
            <p>
              Decision trees are versatile models used in phone recommendation
              systems. They partition data based on features like price, brand,
              and specifications to predict the best phone for a user. They
              offer interpretability, showcasing the decision-making process
              graphically. However, they may overfit complex data and struggle
              with continuous features.
            </p>
          </div>
        </div>
      </div>
    </div>
    <div
      id="section3"
      class="section section-custom-form"
      style="display: flex; flex-direction: column; align-items: center"
    >
      <a
        style="
          text-decoration: none;
          color: #fefefe;
          font-size: 20px;
          display: block;
          margin-left: 80%;
        "
        href="/othermodel"
        >Other Model</a
      >

      <div class="container1">
        <form id="phoneForm">
          <label for="Brand">Brand:</label>
          <input type="text" id="Brand" name="Brand" required />
          <label for="Price">Price:</label>
          <input type="number" id="Price" name="Price" required />
          <label for="Internal storage (GB)">Internal Storage (GB):</label>
          <input
            type="number"
            id="Internal storage (GB)"
            name="Internal storage (GB)"
            required
          />
          <label for="RAM (GB)">RAM (GB):</label>
          <input type="number" id="RAM (GB)" name="RAM (GB)" required />
          <label for="Rear camera">Rear Camera (MP):</label>
          <input type="number" id="Rear camera" name="Rear camera" required />
          <label for="Front camera">Front Camera (MP):</label>
          <input type="number" id="Front camera" name="Front camera" required />
          <label for="Battery capacity (mAh)">Battery Capacity (mAh):</label>
          <input
            type="number"
            id="Battery capacity (mAh)"
            name="Battery capacity (mAh)"
            required
          />
          <button type="submit">Recommend</button>
        </form>
        <div id="result"></div>
      </div>
    </div>

    <div id="myModal" class="modal">
      <div class="modal-content">
        <span class="close">&times;</span>
        <h3 id="modal-title"></h3>
      </div>
    </div>

    <script>
      document.addEventListener("DOMContentLoaded", function () {
        let sections = document.querySelectorAll(".section");
        let currentSection = 0;
        let isScrolling = false;

        window.addEventListener("wheel", function (event) {
          event.preventDefault();
          if (isScrolling) return;
          isScrolling = true;
          setTimeout(function () {
            isScrolling = false;
          }, 1000);

          if (event.deltaY > 0) {
            currentSection++;
          } else {
            currentSection--;
          }
          if (currentSection < 0) {
            currentSection = 0;
          } else if (currentSection >= sections.length) {
            currentSection = sections.length - 1;
          }
          sections[currentSection].scrollIntoView({ behavior: "smooth" });
        });

        document
          .querySelector(".start-button")
          .addEventListener("click", function (event) {
            event.preventDefault();
            document
              .getElementById("section2")
              .scrollIntoView({ behavior: "smooth" });
          });

        document
          .querySelector(".try-other-models-btn")
          .addEventListener("click", function () {
            // Scroll to the next section
            currentSection++;
            if (currentSection >= sections.length) {
              currentSection = sections.length - 1;
            }
            sections[currentSection].scrollIntoView({ behavior: "smooth" });
          });
      });
    </script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script>
      $(document).ready(function () {
        $("#phoneForm").on("submit", function (e) {
          e.preventDefault();
          $.ajax({
            url: "/predict",
            type: "POST",
            data: $("#phoneForm").serialize(),
            success: function (response) {
              $("#result").html(
                "<h3>Recommended Phone: " + response.prediction + "</h3>"
              );
            },
            error: function (error) {
              $("#result").html(
                "<h3>Error: " + error.responseJSON.error + "</h3>"
              );
            },
          });
        });

        $(".close").on("click", function () {
          $("#myModal").css("display", "none");
        });

        window.onclick = function (event) {
          if (event.target == document.getElementById("myModal")) {
            $("#myModal").css("display", "none");
          }
        };
      });
    </script>
  </body>
</html> -->

<!-- 2nd version code -->

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Phone Recommender</title>
    <link rel="stylesheet" href="../static/index.css" />
    <style>
      body {
        overflow: hidden;
      }
      .modal {
        display: none;
        position: fixed;
        z-index: 1;
        padding-top: 60px;
        left: 0;
        top: 0;
        width: 100%;
        height: 100%;
        overflow: auto;
        background-color: rgba(0, 0, 0, 0.4);
      }
      .modal-content {
        background-color: #fefefe;
        margin: 5% auto;
        padding: 20px;
        border: 1px solid #888;
        width: 80%;
        text-align: center;
      }
      .close {
        color: #aaa;
        float: right;
        font-size: 28px;
        font-weight: bold;
      }
      .close:hover,
      .close:focus {
        color: black;
        text-decoration: none;
        cursor: pointer;
      }
      .try-other-models-btn {
        background-color: #4caf50;
        color: white;
        border: none;
        padding: 10px 20px;
        font-size: 16px;
        cursor: pointer;
        margin-top: 20px;
        display: block;
      }
      .try-other-models-btn:hover {
        background-color: #45a049;
      }
    </style>
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
  </head>
  <body>
    <div id="section1" class="section section-start">
      <div class="container">
        <header>Get The Phone Of Your Choice</header>
        <a href="#" class="start-button">START</a>
      </div>
    </div>
    <div id="section2" class="section section-stacy">
      <div class="container">
        <div class="content">
          <div class="model">
            <h2>Models Used</h2>
            <h3>Decision Tree</h3>
            <p>
              Decision trees are versatile models used in phone recommendation
              systems. They partition data based on features like price, brand,
              and specifications to predict the best phone for a user. They
              offer interpretability, showcasing the decision-making process
              graphically. However, they may overfit complex data and struggle
              with continuous features.
            </p>
          </div>
        </div>
      </div>
    </div>
    <div
      id="section3"
      class="section section-custom-form"
      style="display: flex; flex-direction: column; align-items: center"
    >
      <a
        style="
          text-decoration: none;
          color: #fefefe;
          font-size: 20px;
          display: block;
          margin-left: 80%;
        "
        href="/othermodel"
        >Other Model</a
      >

      <div class="container1">
        <form id="phoneForm">
          <label for="Brand">Brand:</label>
          <input type="text" id="Brand" name="Brand" required />
          <label for="Price">Price:</label>
          <input type="number" id="Price" name="Price" required />
          <label for="Internal storage (GB)">Internal Storage (GB):</label>
          <input
            type="number"
            id="Internal storage (GB)"
            name="Internal storage (GB)"
            required
          />
          <label for="RAM (GB)">RAM (GB):</label>
          <input type="number" id="RAM (GB)" name="RAM (GB)" required />
          <label for="Rear camera">Rear Camera (MP):</label>
          <input type="number" id="Rear camera" name="Rear camera" required />
          <label for="Front camera">Front Camera (MP):</label>
          <input type="number" id="Front camera" name="Front camera" required />
          <label for="Battery capacity (mAh)">Battery Capacity (mAh):</label>
          <input
            type="number"
            id="Battery capacity (mAh)"
            name="Battery capacity (mAh)"
            required
          />
          <button type="submit">Recommend</button>
        </form>
        <div id="result"></div>
        <div id="phoneDetails"></div>
        <canvas id="comparisonRadarChart" style="display: none"></canvas>
        <canvas id="comparisonBarChart" style="display: none"></canvas>
        <canvas id="comparisonLineChart" style="display: none"></canvas>
      </div>
    </div>

    <div id="myModal" class="modal">
      <div class="modal-content">
        <span class="close">&times;</span>
        <h3 id="modal-title"></h3>
      </div>
    </div>

    <script>
      document.addEventListener("DOMContentLoaded", function () {
        let sections = document.querySelectorAll(".section");
        let currentSection = 0;
        let isScrolling = false;

        window.addEventListener("wheel", function (event) {
          event.preventDefault();
          if (isScrolling) return;
          isScrolling = true;
          setTimeout(function () {
            isScrolling = false;
          }, 1000);

          if (event.deltaY > 0) {
            currentSection++;
          } else {
            currentSection--;
          }
          if (currentSection < 0) {
            currentSection = 0;
          } else if (currentSection >= sections.length) {
            currentSection = sections.length - 1;
          }
          sections[currentSection].scrollIntoView({ behavior: "smooth" });
        });

        document
          .querySelector(".start-button")
          .addEventListener("click", function (event) {
            event.preventDefault();
            document
              .getElementById("section2")
              .scrollIntoView({ behavior: "smooth" });
          });

        document
          .querySelector(".try-other-models-btn")
          .addEventListener("click", function () {
            // Scroll to the next section
            currentSection++;
            if (currentSection >= sections.length) {
              currentSection = sections.length - 1;
            }
            sections[currentSection].scrollIntoView({ behavior: "smooth" });
          });
      });
    </script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script>
      let radarChart;
      let barChart;
      let lineChart;

      $(document).ready(function () {
        $("#phoneForm").on("submit", function (e) {
          e.preventDefault();
          $.ajax({
            url: "/predict",
            type: "POST",
            data: $("#phoneForm").serialize(),
            success: function (response) {
              $("#result").html(
                "<h3>Recommended Phone: " + response.prediction + "</h3>"
              );

              // Display phone details
              const details = response.phone_details;
              let detailsHtml = "<h4>Phone Details:</h4><table>";
              for (const key in details) {
                detailsHtml +=
                  "<tr><td>" + key + "</td><td>" + details[key] + "</td></tr>";
              }
              detailsHtml += "</table>";
              $("#phoneDetails").html(detailsHtml).fadeIn();

              // Fetch and display the comparison chart
              const formData = $("#phoneForm").serializeArray();
              const formObj = {};
              formData.forEach((item) => (formObj[item.name] = item.value));

              fetch("/stats", {
                method: "POST",
                headers: {
                  "Content-Type": "application/json",
                },
                body: JSON.stringify(formObj),
              })
                .then((response) => response.json())
                .then((data) => {
                  const userValues = [
                    data.user_input.Price,
                    data.user_input["Internal storage (GB)"],
                    data.user_input["RAM (GB)"],
                    data.user_input["Rear camera"],
                    data.user_input["Front camera"],
                    data.user_input["Battery capacity (mAh)"],
                  ];

                  const modelValues = [
                    data.model_output_stats.Price,
                    data.model_output_stats["Internal storage (GB)"],
                    data.model_output_stats["RAM (GB)"],
                    data.model_output_stats["Rear camera"],
                    data.model_output_stats["Front camera"],
                    data.model_output_stats["Battery capacity (mAh)"],
                  ];

                  // Convert to percentages for scaling
                  const maxValues = [
                    100000, // Example max value for Price
                    512, // Max Internal storage (GB)
                    12, // Max RAM (GB)
                    102, // Max Rear camera (MP)
                    48, // Max Front camera (MP)
                    6000, // Max Battery capacity (mAh)
                  ];

                  const userPercentages = userValues.map(
                    (val, i) => (val / maxValues[i]) * 100
                  );
                  const modelPercentages = modelValues.map(
                    (val, i) => (val / maxValues[i]) * 100
                  );

                  // Destroy previous charts if they exist
                  if (radarChart) {
                    radarChart.destroy();
                  }
                  if (barChart) {
                    barChart.destroy();
                  }
                  if (lineChart) {
                    lineChart.destroy();
                  }

                  const labels = [
                    "Price",
                    "Internal storage (GB)",
                    "RAM (GB)",
                    "Rear camera",
                    "Front camera",
                    "Battery capacity (mAh)",
                  ];

                  const radarCtx = document
                    .getElementById("comparisonRadarChart")
                    .getContext("2d");
                  radarChart = new Chart(radarCtx, {
                    type: "radar",
                    data: {
                      labels: labels,
                      datasets: [
                        {
                          label: "Your Input",
                          data: userPercentages,
                          backgroundColor: "rgba(255, 99, 132, 0.2)",
                          borderColor: "rgba(255, 99, 132, 1)",
                          borderWidth: 1,
                        },
                        {
                          label: "Recommended Phone",
                          data: modelPercentages,
                          backgroundColor: "rgba(54, 162, 235, 0.2)",
                          borderColor: "rgba(54, 162, 235, 1)",
                          borderWidth: 1,
                        },
                      ],
                    },
                    options: {
                      scales: {
                        r: {
                          suggestedMin: 0,
                          suggestedMax: 100,
                        },
                      },
                    },
                  });

                  document.getElementById(
                    "comparisonRadarChart"
                  ).style.display = "block";

                  const barCtx = document
                    .getElementById("comparisonBarChart")
                    .getContext("2d");
                  barChart = new Chart(barCtx, {
                    type: "bar",
                    data: {
                      labels: labels,
                      datasets: [
                        {
                          label: "Your Input",
                          data: userValues,
                          backgroundColor: "rgba(255, 99, 132, 0.2)",
                          borderColor: "rgba(255, 99, 132, 1)",
                          borderWidth: 1,
                        },
                        {
                          label: "Recommended Phone",
                          data: modelValues,
                          backgroundColor: "rgba(54, 162, 235, 0.2)",
                          borderColor: "rgba(54, 162, 235, 1)",
                          borderWidth: 1,
                        },
                      ],
                    },
                    options: {
                      scales: {
                        y: {
                          beginAtZero: true,
                        },
                      },
                    },
                  });

                  document.getElementById("comparisonBarChart").style.display =
                    "block";

                  const lineCtx = document
                    .getElementById("comparisonLineChart")
                    .getContext("2d");
                  lineChart = new Chart(lineCtx, {
                    type: "line",
                    data: {
                      labels: labels,
                      datasets: [
                        {
                          label: "Your Input",
                          data: userValues,
                          backgroundColor: "rgba(255, 99, 132, 0.2)",
                          borderColor: "rgba(255, 99, 132, 1)",
                          borderWidth: 1,
                          fill: false,
                        },
                        {
                          label: "Recommended Phone",
                          data: modelValues,
                          backgroundColor: "rgba(54, 162, 235, 0.2)",
                          borderColor: "rgba(54, 162, 235, 1)",
                          borderWidth: 1,
                          fill: false,
                        },
                      ],
                    },
                    options: {
                      scales: {
                        y: {
                          beginAtZero: true,
                        },
                      },
                    },
                  });

                  document.getElementById("comparisonLineChart").style.display =
                    "block";
                });
            },
            error: function (error) {
              $("#result").html(
                "<h3>An error occurred. Please try again.</h3>"
              );
            },
          });
        });
      });
    </script>
  </body>
</html>
